searchNodes=[{"doc":"Entry point for interacting with pages. Pages are built around Pages.Driver.t/0 structs. Drivers hold state about the current connection, implement @behavior Pages.Driver and must implement the String.Chars protocol to transform themselves into HTML. Available drivers Pages.Driver.Conn.t/0 - Given a Plug.Conn.t/0 , this driver will be used. Pages.Driver.LiveView.t/0 - Given a Plug.Conn.t/0 with inner data that appears as if a Phoenix.LiveView is configured, this driver will be used.","ref":"Pages.html","title":"Pages","type":"module"},{"doc":"Simulates clicking on an element at selector with title title .","ref":"Pages.html#click/3","title":"Pages.click/3","type":"function"},{"doc":"Instantiates a new page.","ref":"Pages.html#new/1","title":"Pages.new/1","type":"function"},{"doc":"Submits a form without specifying any attributes.","ref":"Pages.html#submit_form/2","title":"Pages.submit_form/2","type":"function"},{"doc":"Fills in a form with attributes and submits it.","ref":"Pages.html#submit_form/4","title":"Pages.submit_form/4","type":"function"},{"doc":"Fills in a form with attributes without submitting it.","ref":"Pages.html#update_form/4","title":"Pages.update_form/4","type":"function"},{"doc":"Visits path .","ref":"Pages.html#visit/2","title":"Pages.visit/2","type":"function"},{"doc":"","ref":"Pages.html#t:attrs_t/0","title":"Pages.attrs_t/0","type":"type"},{"doc":"","ref":"Pages.html#t:html_t/0","title":"Pages.html_t/0","type":"type"},{"doc":"","ref":"Pages.html#t:page_type_t/0","title":"Pages.page_type_t/0","type":"type"},{"doc":"Constructs CSS selectors via Elixir data structures. See selector/1 for details.","ref":"Pages.Css.html","title":"Pages.Css","type":"module"},{"doc":"","ref":"Pages.Css.html#query/1","title":"Pages.Css.query/1","type":"function"},{"doc":"Accepts a string, atom, or list and returns a CSS string. String syntax When given a string, returns the string. This is useful when you don't know if a selector is already a string. iex&gt; Pages.Css . selector ( &quot;.profile[test-role=&#39;new-members&#39;]&quot; ) &quot;.profile[test-role=&#39;new-members&#39;]&quot; Keyword list syntax The keyword list syntax is intentionally limited; complex selectors are more easily written as strings. The keyword list syntax makes it a bit eaiser to write simple selectors or selectors that use variables: e.g.: Pages.Css . selector ( test_role : &quot;new-members&quot; ) Pages.Css . selector ( id : some_variable ) Keys are expected to be atoms and will be dasherized ( foo_bar -&gt; foo-bar ). Values are expected to be strings or another keyword list. A key/value pair will be converted to an attribute selector: iex&gt; Pages.Css . selector ( test_role : &quot;new-members&quot; ) &quot;[test-role=&#39;new-members&#39;]&quot; A keyword list will be converted to a list of attribute selectors: iex&gt; Pages.Css . selector ( class : &quot;profile&quot; , test_role : &quot;new-members&quot; ) &quot;[class=&#39;profile&#39;][test-role=&#39;new-members&#39;]&quot; (Note that the CSS selector .profile expands to [class~='profile'] which is not equivalent to [class='profile'] . The keyword list syntax will not generate ~= selectors so you should use a string selector such as &quot;.profile[test-role='new-members']&quot; instead if you want ~= semantics. See the CSS spec for details.) When the value is a keyword list, the key is converted to an element selector: iex&gt; Pages.Css . selector ( p : [ class : &quot;profile&quot; , test_role : &quot;new-members&quot; ] ) &quot;p[class=&#39;profile&#39;][test-role=&#39;new-members&#39;]&quot; Regular (non-keyword) list syntax The list syntax is intentionally limited; complex selectors are more easily written as strings. When the value is a regular (non-keyword) list, atoms are converted to element selectors and keyword lists are converted as described above. iex&gt; Pages.Css . selector ( [ [ p : [ class : &quot;profile&quot; , test_role : &quot;new-members&quot; ] ] , :div , [ class : &quot;tag&quot; ] ] ) &quot;p[class=&#39;profile&#39;][test-role=&#39;new-members&#39;] div [class=&#39;tag&#39;]&quot;","ref":"Pages.Css.html#selector/1","title":"Pages.Css.selector/1","type":"function"},{"doc":"","ref":"Pages.Css.html#t:selector/0","title":"Pages.Css.selector/0","type":"type"},{"doc":"Some simple HTML query functions, originally intended for unit tests. Delegates the hard work to Floki . The main query functions are: all/2 : returns all elements matching the selector find/2 : returns the first element that matches the selector find!/2 : like find/2 but raises if more than one element matches the selector Selectors can be a valid CSS selector string, or can be a keyword list. See Pages.Css for keyword list syntax. The attr/2 function can be used to extract attr values, and the text/1 function can be used to extract the text of an HTML fragment. Examples Get the value of a selected option: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; Pages.Html . find ( html , &quot;select option[selected]&quot; ) |&gt; Pages.Html . attr ( &quot;value&quot; ) &quot;a&quot; Get the text of a selected option, raising if there are more than one: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; Pages.Html . find! ( html , &quot;select option[selected]&quot; ) |&gt; Pages.Html . text ( ) &quot;apples&quot; Get the text of all the options: iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; Pages.Html . all ( html , &quot;select option&quot; ) |&gt; Enum . map ( &amp; Pages.Html . text / 1 ) [ &quot;apples&quot; , &quot;bananas&quot; ] Use a keyword list as the selector: iex&gt; html = ~s|&lt;div&gt; &lt;a href=&quot;/logout&quot; test-role=&quot;logout-link&quot;&gt;logout&lt;/a&gt; &lt;/div&gt;| iex&gt; Pages.Html . find! ( html , test_role : &quot;logout-link&quot; ) |&gt; Pages.Html . attr ( &quot;href&quot; ) &quot;/logout&quot;","ref":"Pages.Html.html","title":"Pages.Html","type":"module"},{"doc":"Finds all elements in html that match selector . Returns a Floki HTML tree , which is a list of Floki HTML nodes . iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; Pages.Html . all ( html , &quot;option&quot; ) [ { &quot;option&quot; , [ { &quot;value&quot; , &quot;a&quot; } , { &quot;selected&quot; , &quot;selected&quot; } ] , [ &quot;apples&quot; ] } , { &quot;option&quot; , [ { &quot;value&quot; , &quot;b&quot; } ] , [ &quot;bananas&quot; ] } ]","ref":"Pages.Html.html#all/2","title":"Pages.Html.all/2","type":"function"},{"doc":"Returns the value of attr from the outermost element of html iex&gt; html = ~s|&lt;div&gt; &lt;a href=&quot;/logout&quot; test-role=&quot;logout-link&quot;&gt;logout&lt;/a&gt; &lt;/div&gt;| iex&gt; Pages.Html . find! ( html , test_role : &quot;logout-link&quot; ) |&gt; Pages.Html . attr ( &quot;href&quot; ) &quot;/logout&quot;","ref":"Pages.Html.html#attr/2","title":"Pages.Html.attr/2","type":"function"},{"doc":"Like find/2 but raises unless exactly one element is found.","ref":"Pages.Html.html#find!/2","title":"Pages.Html.find!/2","type":"function"},{"doc":"Finds the first element in html that matches selector . Returns a Floki HTML node . iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; Pages.Html . find ( html , &quot;select option[selected]&quot; ) { &quot;option&quot; , [ { &quot;value&quot; , &quot;a&quot; } , { &quot;selected&quot; , &quot;selected&quot; } ] , [ &quot;apples&quot; ] }","ref":"Pages.Html.html#find/2","title":"Pages.Html.find/2","type":"function"},{"doc":"Returns a map containing the form fields of form selector in html . iex&gt; html = ~s|&lt;form&gt; &lt;input type=&quot;text&quot; name=&quot;color&quot; value=&quot;green&quot;&gt; &lt;textarea name=&quot;desc&quot;&gt;A tree&lt;/textarea&gt; &lt;/form&gt;| iex&gt; Pages.Html . form_fields ( html , &quot;form&quot; ) %{ color : &quot;green&quot; , desc : &quot;A tree&quot; }","ref":"Pages.Html.html#form_fields/2","title":"Pages.Html.form_fields/2","type":"function"},{"doc":"Prints prettified html with a label, and then returns the original html.","ref":"Pages.Html.html#inspect_html/2","title":"Pages.Html.inspect_html/2","type":"function"},{"doc":"Extracts all the meta tags from html . iex&gt; html = ~s|&lt;head&gt; &lt;meta charset=&quot;utf-8&quot;/&gt; &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge&quot;/&gt; &lt;/head&gt;| iex&gt; Pages.Html . meta_tags ( html ) [ %{ &quot;charset&quot; =&gt; &quot;utf-8&quot; } , %{ &quot;content&quot; =&gt; &quot;IE=edge&quot; , &quot;http-equiv&quot; =&gt; &quot;X-UA-Compatible&quot; } ]","ref":"Pages.Html.html#meta_tags/1","title":"Pages.Html.meta_tags/1","type":"function"},{"doc":"Parses and then re-stringifies html , increasing the liklihood that two equivalent HTML strings can be considered equal. iex&gt; a = ~s|&lt;p id=&quot;color&quot;&gt;green&lt;/p&gt;| iex&gt; b = ~s|&lt;p id = &quot;color&quot; &gt;green&lt;/p&gt;| iex&gt; a == b false iex&gt; Pages.Html . normalize ( a ) == Pages.Html . normalize ( b ) true","ref":"Pages.Html.html#normalize/1","title":"Pages.Html.normalize/1","type":"function"},{"doc":"Parses an HTML fragment using Floki.parse_fragment!/1 , returning a Floki HTML tree . html can be an HTML string, a Floki HTML tree, a Floki HTML node, or any struct that implements String.Chars .","ref":"Pages.Html.html#parse/1","title":"Pages.Html.parse/1","type":"function"},{"doc":"Parses an HTML document using Floki.parse_document!/1 , returning a Floki HTML tree .","ref":"Pages.Html.html#parse_doc/1","title":"Pages.Html.parse_doc/1","type":"function"},{"doc":"Pretty-ifies html using Floki.raw_html/2 and its pretty: true option.","ref":"Pages.Html.html#pretty/1","title":"Pages.Html.pretty/1","type":"function"},{"doc":"Returns the text value of html iex&gt; html = ~s|&lt;select&gt; &lt;option value=&quot;a&quot; selected&gt;apples&lt;/option&gt; &lt;option value=&quot;b&quot;&gt;bananas&lt;/option&gt; &lt;/select&gt;| iex&gt; Pages.Html . find! ( html , &quot;select option[selected]&quot; ) |&gt; Pages.Html . text ( ) &quot;apples&quot;","ref":"Pages.Html.html#text/1","title":"Pages.Html.text/1","type":"function"},{"doc":"","ref":"Pages.Html.html#t:attr/0","title":"Pages.Html.attr/0","type":"type"},{"doc":"","ref":"Pages.Html.html#t:html/0","title":"Pages.Html.html/0","type":"type"},{"doc":"","ref":"Pages.Html.html#t:selector/0","title":"Pages.Html.selector/0","type":"type"},{"doc":"Functions that transform Floki HTML","ref":"Pages.HtmlTransformer.html","title":"Pages.HtmlTransformer","type":"module"},{"doc":"","ref":"Pages.HtmlTransformer.html#filter_by_text/2","title":"Pages.HtmlTransformer.filter_by_text/2","type":"function"},{"doc":"","ref":"Pages.HtmlTransformer.html#to_attribute_values/2","title":"Pages.HtmlTransformer.to_attribute_values/2","type":"function"},{"doc":"","ref":"Pages.HtmlTransformer.html#to_text/1","title":"Pages.HtmlTransformer.to_text/1","type":"function"},{"doc":"Defines types and behaviours that page drivers must implement.","ref":"Pages.Driver.html","title":"Pages.Driver","type":"behaviour"},{"doc":"Click an element within a page.","ref":"Pages.Driver.html#c:click/3","title":"Pages.Driver.click/3","type":"callback"},{"doc":"Submit a form targeted by the given selector.","ref":"Pages.Driver.html#c:submit_form/2","title":"Pages.Driver.submit_form/2","type":"callback"},{"doc":"Fills in a form with the attributes and submits it.","ref":"Pages.Driver.html#c:submit_form/4","title":"Pages.Driver.submit_form/4","type":"callback"},{"doc":"Fills in a form with the attributes without submitting it.","ref":"Pages.Driver.html#c:update_form/4","title":"Pages.Driver.update_form/4","type":"callback"},{"doc":"Navigate directly to a page.","ref":"Pages.Driver.html#c:visit/2","title":"Pages.Driver.visit/2","type":"callback"},{"doc":"","ref":"Pages.Driver.html#t:t/0","title":"Pages.Driver.t/0","type":"type"},{"doc":"A page driver for interacting with Phoenix controllers.","ref":"Pages.Driver.Conn.html","title":"Pages.Driver.Conn","type":"module"},{"doc":"","ref":"Pages.Driver.Conn.html#new/1","title":"Pages.Driver.Conn.new/1","type":"function"},{"doc":"Callback implementation for Pages.Driver.visit/2 .","ref":"Pages.Driver.Conn.html#visit/2","title":"Pages.Driver.Conn.visit/2","type":"function"},{"doc":"","ref":"Pages.Driver.Conn.html#t:t/0","title":"Pages.Driver.Conn.t/0","type":"type"},{"doc":"A page driver for interacting with Phoenix.LiveView pages.","ref":"Pages.Driver.LiveView.html","title":"Pages.Driver.LiveView","type":"module"},{"doc":"Callback implementation for Pages.Driver.click/3 .","ref":"Pages.Driver.LiveView.html#click/3","title":"Pages.Driver.LiveView.click/3","type":"function"},{"doc":"","ref":"Pages.Driver.LiveView.html#new/1","title":"Pages.Driver.LiveView.new/1","type":"function"},{"doc":"","ref":"Pages.Driver.LiveView.html#new/2","title":"Pages.Driver.LiveView.new/2","type":"function"},{"doc":"Callback implementation for Pages.Driver.submit_form/2 .","ref":"Pages.Driver.LiveView.html#submit_form/2","title":"Pages.Driver.LiveView.submit_form/2","type":"function"},{"doc":"Callback implementation for Pages.Driver.submit_form/4 .","ref":"Pages.Driver.LiveView.html#submit_form/4","title":"Pages.Driver.LiveView.submit_form/4","type":"function"},{"doc":"Callback implementation for Pages.Driver.update_form/4 .","ref":"Pages.Driver.LiveView.html#update_form/4","title":"Pages.Driver.LiveView.update_form/4","type":"function"},{"doc":"Go to the given URL, assuming that it will be a new LiveView","ref":"Pages.Driver.LiveView.html#visit/2","title":"Pages.Driver.LiveView.visit/2","type":"function"},{"doc":"","ref":"Pages.Driver.LiveView.html#t:t/0","title":"Pages.Driver.LiveView.t/0","type":"type"},{"doc":"A Page Object pattern for interacting with websites. This library can be used to facilitate testing of Phoenix controllers and LiveView pages in the context of ExUnit, and may be used as the basis of other drivers. Note : prior to the release of 1.0.0 , minor releases of this library may include breaking changes. While new, this library is undergoing rapid development. A goal is to reach a stable API and a 1.0.0 release as soon as possible. See the API reference for more info.","ref":"readme.html","title":"Pages","type":"extras"},{"doc":"def deps do [ { :pages , &quot;~&gt; 0.2.3&quot; , only : :test } ] end","ref":"readme.html#installation","title":"Pages - Installation","type":"extras"},{"doc":"coming soon","ref":"readme.html#usage","title":"Pages - Usage","type":"extras"},{"doc":"Copyright 2022 synchronal.dev Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]